{{
  Modular Programming Technique Demo

  Configured for Demoboard with VGA + Keyboard
}}

CON

  _clkmode  = xtal1 + pll16x
  _xinfreq  = 5_000_000                                            


  
OBJ

  key       : "keyboard"
  vid       : "vga_40x18_rom_text"
  bsf       : "bufstrfmt"
  clock     : "clock"
  
  ui        : "ui_methods"

  setup     : "setup"

PUB Main | c

  key.start(26, 27)
  vid.start(16, $7FFC)
  setup.loadsetup

  waitcnt(cnt + clkfreq/10) 'give cogs time to start
  bsf.setbuf(key.pasmbase, key.pasmend) 'recycle keyboard pasm image

  clock.start

{
  Note that if this was a real application there would be code here
  navigating among numerous modules similar to Setup, each implementing
  advanced functionality using the tools provided by ui_methods and
  others.  Note particularly the clock module, which is application
  specific but which would be used by all other modules to maintain
  the clock display while various different user functions are ongoing.
}
  repeat
    ui.drawheader(string("Modular Spin Demo"),5, 6)
    c := ui.picklist(string("Enter Setup (the demo)", 13, "Do Something Else", 13, "Freeze the background"), 5, 8, -1)
    case c
      0:
        setup.setup
      1:
        ui.flashmsg(string("Sorry, there isn't", 13, "anything else to do!"), %%300, 3)
      2:
        ui.screenmsg(string("Unlike the rest of the", 13, "Application, this 5 second", 13, {
      } "delay is not calling the", 13, "background.  Notice the clock..."), %%002)
        waitcnt(cnt + clkfreq * 5)
        



  